<template>
  <v-layout>
    <div
      class="d-flex h-100 w-100 pt-3 pb-3 justify-content-center align-items-center"
    >
      <div class="card-main d-flex flex-column w-95 w-sm-75">
        <div
          class="d-flex ml-3 mr-3 p-3 align-items-center justify-content-start border-bottom mb-3"
        >
          <plusIcon class="icon-small-squad icon--brown" />
          <span class="text--gray font-large font-bold ml-3"
            >Cadastro de avaliações</span
          >
        </div>
        <div class="d-flex ml-3 mr-3 mb-3 h-max-300">
          <input
            type="text"
            class="input input-rounded w-100 text--gray font-small"
            placeholder="Descrição"
            v-model="model.description"
          />
        </div>
        <div
          class="d-flex flex-column h-max-300 scrollable ml-3 mr-3 mb-3 p-3 border"
          ref="scrollable"
          v-if="questionsTmp.length"
        >
          <div
            class="d-flex flex-column font-small border p-2 mb-3"
            style="position:realtive"
            v-for="(question, index) of questionsTmp"
            :key="index"
          >
            <p class="text--gray font-small font-bold">
              {{ question.statement }}
            </p>
            <label
              class="text--gray font-small"
              v-for="(answer, index) of question.answers"
              :key="index"
            >
              {{ index + 1 }}{{ answer.correct ? " [X] " : " [&nbsp;&nbsp;] "
              }}{{ answer.text }}
            </label>
          </div>
        </div>
        <div
          class="d-flex ml-3 mr-2 mb-3 h-max-300 scrollable"
          v-on:click="addQuestion"
        >
          <div class="d-flex w-100 pt-3 pb-3 border">
            <div
              class="d-flex align-items-center justify-content-center col-12 font-small"
            >
              <plusIcon class="icon-x-small-squad icon--brown mb-1" />
              <label class="text--gray text-small m-0 ml-2"
                >Adicionar questão</label
              >
            </div>
          </div>
        </div>
        <div class="d-flex ml-3 mr-2 h-max-300 scrollable">
          <div class="d-flex w-100 pt-3 pb-3 border">
            <div
              class="d-flex align-items-center justify-content-center col-12 font-small"
            >
              <plusIcon class="icon-x-small-squad icon--brown mb-1" />
              <label class="text--gray text-small m-0 ml-2"
                >Criar nova questão</label
              >
            </div>
          </div>
        </div>
        <div class="d-flex pb-3 pt-3 ml-3 mr-3 mt-3 border-top">
          <div class="d-flex col-6 justify-content-start">
            <button
              class="btn d-flex justify-content-center bg-none p-2 pl-4 pr-4 btn text-green font-medium"
              v-on:click="cancel"
              title="Cancelar"
            >
              Cancelar
            </button>
          </div>
          <div class="d-flex col-6 justify-content-end">
            <button
              class="btn d-flex justify-content-center bg--primary p-2 pl-4 pr-4 btn text-white font-medium"
              title="Salvar instituição"
              v-on:click="save"
            >
              Salvar
            </button>
          </div>
        </div>
      </div>
    </div>
  </v-layout>
</template>
<script>
/*  ======================
 *   Cadastro de Questões
 *  ======================
 */
import VLayout from "@/layouts/Default";
import plusIcon from "@/static/icon/plus.svg";
import Evaluation from "@/models/Evaluation";
import questions from "@/mocks/questoes.json";

export default {
  name: "login",
  data() {
    return {
      model: new Evaluation(),
      questionsTmp: [],
      questionsAvailables: questions
    };
  },
  validations: {},
  methods: {
    save() {
      const self = this;
      console.warn(self.model.json);
      self.$notify({
        group: "default",
        type: "success",
        title: "Sucesso",
        text: "Avaliação cadastrada com sucesso!"
      });
    },
    cancel() {
      const self = this;
      self.model = new Evaluation();
      self.questionsTmp = [];
    },
    addQuestion() {
      const self = this;
      const acutalQuestion = self.getRandomIntInclusive(0, 4);
      self.questionsTmp.push(self.questionsAvailables[acutalQuestion]);
      self.model.questions.push(self.questionsAvailables[acutalQuestion]);
      console.warn(self.questionsTmp);
    },
    getRandomIntInclusive(min, max) {
      min = Math.ceil(min);
      max = Math.floor(max);
      return Math.floor(Math.random() * (max - min + 1)) + min;
    }
  },
  updated() {
    const self = this;
    if (self.$refs.scrollable) {
      self.$refs.scrollable.scrollTop += self.$refs.scrollable.scrollHeight;
    }
  },
  beforeMount() {
    const self = this;
    if (self.$route.params.obj) {
      self.model.montaModel(self.$route.params.obj);
    }
    console.warn(self.questionsAvailables);
  },
  computed: {},
  components: {
    VLayout,
    plusIcon
  }
};
</script>
